import { defineComponent, openBlock, createElementBlock, normalizeClass, unref, toDisplayString, ref, createElementVNode } from "vue";
import { setupTemplate, setupBind } from "@supermatic-ui/vue-core";
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "SupermaticButton",
  props: {
    metadata: null,
    dataBinding: null
  },
  setup(__props) {
    const props = __props;
    const label = setupTemplate(props.dataBinding, props.metadata.button.text);
    const className = setupTemplate(props.dataBinding, props.metadata.className);
    const click = () => {
      console.log("[SupermaticButton] click");
      if (props.metadata.button.action) {
        console.log("[SupermaticButton] action call", props.metadata.button.action);
        props.dataBinding.handleAction(props.metadata.button.action);
      }
    };
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("button", {
        class: normalizeClass(unref(className)),
        onClick: _cache[0] || (_cache[0] = ($event) => click())
      }, toDisplayString(unref(label)), 3);
    };
  }
});
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "SupermaticLabel",
  props: {
    metadata: null,
    dataBinding: null
  },
  setup(__props) {
    const props = __props;
    const label = setupTemplate(props.dataBinding, props.metadata.label.text);
    const className = setupTemplate(props.dataBinding, props.metadata.className);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("span", {
        class: normalizeClass(unref(className))
      }, toDisplayString(unref(label)), 3);
    };
  }
});
const _hoisted_1 = ["type", "value", "placeholder"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "SupermaticInput",
  props: {
    metadata: null,
    dataBinding: null
  },
  setup(__props) {
    const props = __props;
    const label = setupTemplate(props.dataBinding, props.metadata.input.label);
    const labelClassName = setupTemplate(props.dataBinding, props.metadata.input.labelClassName);
    const inputClassName = setupTemplate(props.dataBinding, props.metadata.input.inputClassName);
    const inputType = setupTemplate(props.dataBinding, props.metadata.input.inputType);
    const placeholder = setupTemplate(props.dataBinding, props.metadata.input.placeholder);
    const className = setupTemplate(props.dataBinding, props.metadata.className);
    const modelRef = ref("");
    const inputBind = setupBind(props.dataBinding, props.metadata.binding, modelRef);
    const updateInputValue = (e) => inputBind.set(e.target.value);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(unref(className))
      }, [
        createElementVNode("label", {
          class: normalizeClass(unref(labelClassName))
        }, toDisplayString(unref(label)), 3),
        createElementVNode("input", {
          type: unref(inputType),
          value: modelRef.value,
          onInput: _cache[0] || (_cache[0] = ($event) => updateInputValue($event)),
          placeholder: unref(placeholder),
          class: normalizeClass(unref(inputClassName))
        }, null, 42, _hoisted_1)
      ], 2);
    };
  }
});
const components = {
  SupermaticButton: _sfc_main$2,
  SupermaticLabel: _sfc_main$1,
  SupermaticInput: _sfc_main
};
const UseSupermaticUiComponents = {
  install: (app) => {
    for (let componentKey in components) {
      console.log("install component", componentKey);
      app.component(componentKey, components[componentKey]);
    }
  }
};
export {
  _sfc_main$2 as SupermaticButton,
  _sfc_main as SupermaticInput,
  _sfc_main$1 as SupermaticLabel,
  UseSupermaticUiComponents
};
