(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("vue"), require("@supermatic-ui/vue-core")) : typeof define === "function" && define.amd ? define(["exports", "vue", "@supermatic-ui/vue-core"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global["@supermatic-ui/vue-components"] = {}, global.Vue, global.vueCore));
})(this, function(exports2, vue, vueCore) {
  "use strict";
  const _sfc_main$2 = /* @__PURE__ */ vue.defineComponent({
    __name: "SupermaticButton",
    props: {
      metadata: null,
      dataBinding: null
    },
    setup(__props) {
      const props = __props;
      const label = vueCore.setupTemplate(props.dataBinding, props.metadata.button.text);
      const className = vueCore.setupTemplate(props.dataBinding, props.metadata.className);
      const click = () => {
        console.log("[SupermaticButton] click");
        if (props.metadata.button.action) {
          console.log("[SupermaticButton] action call", props.metadata.button.action);
          props.dataBinding.handleAction(props.metadata.button.action);
        }
      };
      return (_ctx, _cache) => {
        return vue.openBlock(), vue.createElementBlock("button", {
          class: vue.normalizeClass(vue.unref(className)),
          onClick: _cache[0] || (_cache[0] = ($event) => click())
        }, vue.toDisplayString(vue.unref(label)), 3);
      };
    }
  });
  const _sfc_main$1 = /* @__PURE__ */ vue.defineComponent({
    __name: "SupermaticLabel",
    props: {
      metadata: null,
      dataBinding: null
    },
    setup(__props) {
      const props = __props;
      const label = vueCore.setupTemplate(props.dataBinding, props.metadata.label.text);
      const className = vueCore.setupTemplate(props.dataBinding, props.metadata.className);
      return (_ctx, _cache) => {
        return vue.openBlock(), vue.createElementBlock("span", {
          class: vue.normalizeClass(vue.unref(className))
        }, vue.toDisplayString(vue.unref(label)), 3);
      };
    }
  });
  const _hoisted_1 = ["type", "value", "placeholder"];
  const _sfc_main = /* @__PURE__ */ vue.defineComponent({
    __name: "SupermaticInput",
    props: {
      metadata: null,
      dataBinding: null
    },
    setup(__props) {
      const props = __props;
      const label = vueCore.setupTemplate(props.dataBinding, props.metadata.input.label);
      const labelClassName = vueCore.setupTemplate(props.dataBinding, props.metadata.input.labelClassName);
      const inputClassName = vueCore.setupTemplate(props.dataBinding, props.metadata.input.inputClassName);
      const inputType = vueCore.setupTemplate(props.dataBinding, props.metadata.input.inputType);
      const placeholder = vueCore.setupTemplate(props.dataBinding, props.metadata.input.placeholder);
      const className = vueCore.setupTemplate(props.dataBinding, props.metadata.className);
      const modelRef = vue.ref("");
      const inputBind = vueCore.setupBind(props.dataBinding, props.metadata.binding, modelRef);
      const updateInputValue = (e) => inputBind.set(e.target.value);
      return (_ctx, _cache) => {
        return vue.openBlock(), vue.createElementBlock("div", {
          class: vue.normalizeClass(vue.unref(className))
        }, [
          vue.createElementVNode("label", {
            class: vue.normalizeClass(vue.unref(labelClassName))
          }, vue.toDisplayString(vue.unref(label)), 3),
          vue.createElementVNode("input", {
            type: vue.unref(inputType),
            value: modelRef.value,
            onInput: _cache[0] || (_cache[0] = ($event) => updateInputValue($event)),
            placeholder: vue.unref(placeholder),
            class: vue.normalizeClass(vue.unref(inputClassName))
          }, null, 42, _hoisted_1)
        ], 2);
      };
    }
  });
  const components = {
    SupermaticButton: _sfc_main$2,
    SupermaticLabel: _sfc_main$1,
    SupermaticInput: _sfc_main
  };
  const UseSupermaticUiComponents = {
    install: (app) => {
      for (let componentKey in components) {
        console.log("install component", componentKey);
        app.component(componentKey, components[componentKey]);
      }
    }
  };
  exports2.SupermaticButton = _sfc_main$2;
  exports2.SupermaticInput = _sfc_main;
  exports2.SupermaticLabel = _sfc_main$1;
  exports2.UseSupermaticUiComponents = UseSupermaticUiComponents;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
